#ifndef QUEUE_HPP
#define QUEUE_HPP

#include <cstddef>

// Linked list based queue after Sedgewick and Wayne, Algorithms 4th ed, Algorithm 1.3

template <typename T>
class Queue {

private:

    ////////////////////////////////////
    class Node {
    public:
        T item;
        Node *next;
        };

public:

    ////////////////////////////////////
    class iterator;
    friend class iterator;
    class iterator {

    public:

        iterator( Node *c );

        iterator& operator++();
        iterator operator++(int);

        T operator*();
        bool operator!=( typename Queue<T>::iterator );

    private:

        Node *curr;
        };

    ////////////////////////////////////

    Queue( void );
    ~Queue( void );

    void enqueue( T &item );
    T dequeue( void );

    bool is_empty( void );
    size_t size( void );

    iterator begin( void );
    iterator end( void );


private:

    size_t N;
    Node *first;
    Node *last;

    };



#endif

